--------------------------------------
MUI BetterString MCC class - ChangeLog
--------------------------------------

#### v11.33 RELEASE ###########################################################

2018-10-09 Thore Böckelmann <tboeckel@gmx.de>

  * PrintString.c: integrated the display of transparent text for AmigaOS3 as
    known from MUI5 for AmigaOS. Now the alternative text can be displayed with
    50% transparency on AmigaOS3, too.

2018-10-04 Thore Böckelmann <tboeckel@gmx.de>

  * PrintString.c: the inactive contents are displayed with 50% transparency in
    case the system and the screen support this effect. Otherwise the usual
    italic style is used.

#### v11.32 RELEASE ###########################################################

#### v11.31 RELEASE (special MUI 5.0-2017R3 release) ##########################

2016-09-16 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: added DoSuperNew() to be able to specify additional tags
    directly during OM_NEW instead of having to use SetAttrs() afterwards.
  * mcc/PrintString.c: added one more check for non-input objects to avoid
    drawing a cursor when none is desired.

2016-09-07 Thore Böckelmann <tboeckel@gmx.de>

  * library.c: moved the system and CPU description behind the copyright part.

2016-08-15 Thore Böckelmann <tboeckel@gmx.de>

  * all/Debug.c: declare inlined _INDENT() function as static to avoid warnings
    of GCC5.

2016-08-12 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/Makefile: generate ISO8859-1 encoded catalogs instead of UTF8 encoded
    ones.

#### v11.30 RELEASE ###########################################################

2016-08-06 Jens Maus <mail@jens-maus.de>

  * misc: final 11.30 release preparations
  * mcc/HandleInput.c: updated MySPrintf() function to use a inline macros for
    AROS and MORPHOS builds instead.
  * include: updated SDI headers.

#### v11.29 RELEASE ###########################################################

2015-03-21 Jens Maus <mail@jens-maus.de>

  * misc: final 11.29 release preparations

2014-08-27 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/turkish.po: added turkish translation.

2014-04-09 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/HandleInput.c: added a missing end of string check when double/tripple
    clicking the contents. This might have caused BetterString.mcc to enter an
    endless loop. Thanks to Mikhail Malyshev for the hint. Please note however
    that the used russian locale was the component which triggered this bug in
    the first place.

2014-04-08 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcp/CreatePrefsGroup.c: disable the custom selection
    pointer if MUI already handles this. The selection pointer can then be
    globally enabled/disabled in MUI prefs (AmigaOS only).

#### v11.28 RELEASE ###########################################################

2014-04-04 Jens Maus <mail@jens-maus.de>

  * misc: final 11.28 release preparations

2014-04-01 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale: added a new header line to the .po files to specify a correct
    name for the generated .catalog file. This fixes #18.

2014-04-01 Jens Maus <mail@jens-maus.de>

  * tools/mkrelease.sh: fixed a problem where the release script didn't rename
    the catalog files correctly to "BetterString_mcp.catalog". This fixes #18.

#### v11.27 RELEASE ###########################################################

2014-03-30 Jens Maus <mail@jens-maus.de>

  * misc: final 11.27 release preparations
  * tools/mkrelease.sh: modified release script to dynamically identify all
    catalogs to be included in the release archive.
  * mcc/FileNameCompl.c: added <dos/obsolete.h> which is required for the OS4
    build with newer SDKs.
  * mcp/locale/dutch.po: added new dutch translation
  * mcp/locale/spanish.po: added new spanish translation

2014-02-18 Jens Maus <mail@jens-maus.de>

  * mcp/locale: all catalog translations have now been moved to use the free
    services of transifex (http://www.transifex.com/projects/p/bstring-mcc/)

2014-01-13 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/danish.ct: updated danish translation kindly provided by Niels
    Bache.

#### v11.26 RELEASE ###########################################################

2013-12-13 Jens Maus <mail@jens-maus.de>

  * misc: final 11.26 release preparations

2013-07-21 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/ClipboardServer.c: fixed a potential NULL pointer use when str had been
    NULL and strlen() in StringToClipboard() was called.

2013-04-30 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/greek.ct: updated greek translation kindly provided by Antonis
    Iliakis.

#### v11.25 RELEASE ###########################################################

2013-04-25 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.25 release preparations
  * mcp/BetterString_mcp.h: changed default colors for marked text to match the
    well-known defaults of string.mui.

2013-04-24 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/greek.ct: updated greek translation kindly provided by Antonis
    Iliakis.

2013-03-28 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: fixed a redraw issue with bitmap backgrounds.

2013-03-06 Thore Böckelmann <tboeckel@gmx.de>

  * include/mccinit.c, include/shellstart.c: rearranged the code to ensure that
    trying to start the final class from a shell does not crash.

2013-02-07 Thore Böckelmann <tboeckel@gmx.de>

  * mcc, mcp: when running under MUI 4.x BetterString will automatically fall
    back to the background settings of the internal String.mui class to ensure
    a consistent look of all string objects unless an application explicitly
    sets a custom background. With MUI 3.x the user will still have to configure
    the two background images, because here String.mui is based on intuition's
    strgclass and hence there is nothing which could be cloned.

2013-02-06 Thore Böckelmann <tboeckel@gmx.de>

  * mcc, mcp: completely removed the custom frame setting. Since BetterString is
    meant as a replacement class for String.mui it is much more intuitive to have
    to do the same steps when creating a BetterString object as when creating a
    normal String.mui object. Furthermore it is also more intuitive for the user
    to get the same look for all string objects rather than have a different look
    for BetterString objects.

2013-01-21 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/misc: completely reworked the string buffer handling to keep a size
    information for each single string (normal, undo, original). Before the class
    kept a size information for the normal contents string only and after the
    first undo action this size information was bogus but still used whenever the
    current allocation size needed to be checked. Upon the next contents change
    memory was trashed due to this wrong size information.

2013-01-15 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/CreatePrefsGroup.c: used a fixed height of 0 to enforce a suitable
    height of all pen and frame buttons.

#### v11.24 RELEASE ###########################################################

2012-12-20 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.24 release preparations

2012-12-19 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/InitConfig.c: fixed an ancient bug which prevented the custom mouse
    pointer setting to be successfully applied if the default setting had to
    be used.

2012-12-14 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcc/HandleInput.c: fixed a selection issue triggered by
    YAM which was caused by the last change. Thanks to Christoph Pölzl for the
    hint.

2012-12-13 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcc/HandleInput.c: don't perform the "select all"
    operation immediately if the "select on active" feature is enabled and the
    object becomes active, but defer this a bit. This makes it possible to
    activate the object with the mouse and start to mark a section while the
    mouse button is still pressed. And this also fixes the issue that keeping
    the mouse button pressed always started a selection from the beginning of
    the contents instead of the current position. Thanks to Christoph Pölzl for
    the hint.

2012-12-12 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: added a workaround for an old and ancient MUI bug when
    having to deal with removed notifications while causing further set()
    operations which trigger nested notification checks. Thanks for Steffen
    Gutmann for all the hints regarding this issue, as MUIbase was the only
    known affected application so far.

2012-12-10 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/ClipboardServer.c: changed the ClipboardToString() functions to return
    a boolean value to indicate success and  to avoid memory leaks.
  * mcc/HandleInput.c: clear the selection only if reading from clipboard was
    successful.

2012-12-09 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/AllocFunctions.c: use Alloc/FreeVecPooled instead of Alloc/FreePooled.
  * mcc/misc: completely reworked the string expansion functions and added lots
    of NULL pointer checks.
  * mcc/misc: use memmove() instead of strcpy() to move characters within the
    contents string as strcpy() is not guarateed to handle overlapping copies
    correctly. Also replaced strcpyback() by memmove().
  * mcc/Dispatcher.c: free the original string in OM_DISPOSE to avoid memory
    leaks.

2012-12-07 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcc/GetSetAttrs.c: use a private attribute to temporarily
    disable the "select on feature" feature when the window is put to sleep.
    This makes it possible to use the notification even if the feature is
    enabled by the application instead of the global/local configuration.
  * mcc/Dispatcher.c: added some more security checks before adding the notify
    as the function might be called during OM_NEW and accessing _win(obj) is not
    yet allowed at that time.

2012-12-06 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: add the notification for MUIA_Window_Sleep as well if the
    "select on active" feature has been acivated by setting the attribue
    MUIA_BettString_SelectOnActive to TRUE. This will be remembered until the
    method MUIM_Cleanup finally removes the notification again.

2012-12-05 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: added a notification for MUIA_Window_Sleep to be able to
    deactivate the "select on active" feature until the window is woken up again.
    This is necessary, because MUIA_Window_Sleep will modify the active object
    and hence the object will go inactive and active again and thus select all
    its contents, even if this was not the case before. This fixes YAM ticket
    #360.
  * mcc/GetSetAttrs.c: don't redraw the object if MUIA_BettString_SelectOnActive
    is modified as this does not change anything visible unless the objects goes
    active or inactive.

2012-12-01 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: fixed a wrong handling of queued notifications.

2012-11-27 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/HandleInput.c: added some missing redraw events in case BetterString.mcc
    reacted on certain standard MUI key shortcuts.

2012-11-19 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Pointer.c: make use of the standard mouse pointer images in the AmigaOS4
    build if intuition.library 53.37 is available.

2012-09-20 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/Dispatcher.c: don't trigger notifications in
    MUIM_Mccprefs_ConfigToGadgets.
  * mcp/Dispatcher.c: save strings with their real length only instead of their
    maximum length to assist MUI4's realtime prefs.
  * mcp/Dispatcher.c: remove settings from the configuration if they match the
    default value.

2012-09-13 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: added the former X offset again when drawing the complete
    imagery. AfAOS' Text() replacement seems to need this additional space to
    correctly print texts starting with 'J' or '*' when certain fonts are used.
    Other systems might trash innocent memory. So better put it back in.

2012-09-12 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcc/InitConfig.c: apply the current configuration before
    calling the superclass' MUIM_Setup to ensure the frame settings are applied
    correctly.

2012-09-11 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: use the normal object's dimensions when calculating the
    amount of fitting characters instead of deriving the dimensions from some
    other values.

2012-08-28 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/CreatePrefsGroup.c: adjusted the crawling text to better match the
    capabilities of Crawling.mcc.
  * mcc/HandleInput.c: added support for the standard cut, copy, paste, undo and
    redo keys of MUI4.

#### v11.23 RELEASE ###########################################################

2012-08-05 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.23 release preparations

2012-07-19 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: don't handle MUIA_Disabled twice in OM_SET. All the
    necessary stuff is already done by recalculating the flags.

2012-06-19 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/AllocFunctions.c: don't allocate locked memory.

2012-05-14 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/Makefile: removed .catalog files in clean target.
  * mcp/locale/italian.ct: updated italian translation kindly provided by Samir
    Hawamdeh.

#### v11.22 RELEASE ###########################################################

2012-05-12 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.22 release preparations
  * mcp/Makefile: readded -DNO_INLINE_STDARG for aros-ppc and aros-x86_64
    target as otherwise the cross-compiler won't build for these targets and
    raise some unterminated macros errors.

2012-05-10 Jens Langner <Jens.Langner@light-speed.de>

  * GetSetAttr.c, HandleInput.c, private.h: implemented a new
    MUIA_BetterString_NoNotify attribute which will allow to prevent
    betterstring from sending out notifications on changes of the
    MUIA_String_Contents attribute. This should help applications to
    ensure that only one notification is triggered in case multiple
    operations are performed in a row which change the content of the
    string object.

2012-05-10 Thore Böckelmann <tboeckel@gmx.de>

  * Dispatcher.c, HandleInput.c: MUIM_BetterString_Insert will now correctly
    trigger a notification of MUIA_String_Contents.

2012-05-03 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: fixed the OM_SET method to redraw the object only if
    there is something to be redrawn due to modified attributes. Especially
    setting the disabled state to the same value again will cause one redraw
    event only instead of two.

2012-04-13 Jens Langner <Jens.Langner@light-speed.de>

  * mcp/CreatePrefsGroup.c: reordered the checkmark objects so that they are
    horizontal aligned properly to the previous objects.
  * mcp/private.h: removed "Font" config object from object enum list or otherwise
    the .mcp crashes.

2012-04-13 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: use MUIPEN() macro for all uses of pens allocated by MUI.
  * mcc/Dispatcher.c, GetSetAttrs.c, HandleInput.c, mcc/PrintString.c: replaced
    all direct peeking to public MUI structures by the appropriate macro calls.
  * mcc/PrintString.c: the background must be drawn with the object's left/top
    edge as offsets to let an inherited background be drawn correctly.
  * mcp/CreatePrefsGroup.c: removed the custom font setting as BetterString
    should behave like the built-in string class. Furthermore the advanced font
    specs of MUI4 can only be applied if the font inheritance mechanism would be
    fully replicated in BetterString.
  * mcc/misc: removed the custom font support as stated above.
  * mcc/InitConfig.c: fixed yet another possible invalid pointer value after a
    configuration change.

2012-04-07 Jens Langner <Jens.Langner@light-speed.de>

  * Makefile: removed -funroll-loops as this option is potentially
    dangerous.

2012-04-02 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: call InitConfig() after the superclass' MUIM_Setup
    succeeded to avoid orphaned pen allocations.
  * mcp/BetterString_mcp.h: fixed duplicate config ID for marked text color
    and select on activate items. This will require every user to check the
    settings and save them again, unfortunately.
  * mcc/InitConfig.c: string pointers obtained from the MUI configuration must
    be copied instead of rembembered directly. With MUI4's realtime prefs the
    pointer might become invalid at any time and hence the class would operate
    on invalid data after that.

2012-03-29 Thore Böckelmann <tboeckel@gmx.de>

  * Makefile: added __amigaos3__ symbol for the OS3 build.

2012-01-29 Matthias Rustler <mrustler@gmx.de>

  * Backport of AROS fixes.
  * SDI headers updated.

#### v11.21 RELEASE ###########################################################

2011-11-26 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.21 release preparations

2011-09-12 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: fixed the slightly wrong background drawing when
    gradients are being used.

2011-01-04 Thore Böckelmann <tboeckel@gmx.de>

  * all/Makefile: fixed the dependency generation to respect the system specific
    object file path.

2010-10-05 Thore Böckelmann <tboeckel@gmx.de>

  * include/mccinit.c: make sure that removing the library during LibClose()
    really operates on the correct base. Calling LibExpunge() on MorphOS is
    wrong, since that takes no parameter but expects the base to be in A6. We
    work around this by using an additional function which gets called from
    LibClose() and LibExpunge() with the correct base pointer.

#### v11.20 RELEASE ###########################################################

2010-09-23 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.20 release preparations

2010-09-17 Pär Boberg <pbobbenb@spray.se>

  * mcp/locale/swedish.ct: new file generated by FlexCat 2.7.

2010-09-08 Mariusz Danilewicz <mandi@interia.pl>

  * AUTHORS: added translators section (please check and update missing persons).

2010-09-07 Thore Böckelmann <tboeckel@gmx.de>

  * mccinit.c: added missing #include <string.h> for memset().

2010-09-03 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/AllocFunctions.c, mcc/ClipboardServer.c: applied the same fix for the
    semaphores.
  * mccinit.c: clear the library semaphore before calling InitSemaphore(). This
    fixes bug #3058668.

#### v11.19 RELEASE ###########################################################

2010-09-01 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.19 release preparations

2010-08-31 Jens Langner <Jens.Langner@light-speed.de>

  * Makefile: updated all makefiles to compile with -O2 for AROS
  * mccinit.c, SDI-compiler.h: updated to latest versions

2010-08-27 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/italian.ct: updated italian translation provided by Samir
    Hawamdeh.

2010-08-17 Thore Böckelmann <tboeckel@gmx.de>

  * mccinit.c, SDI_compiler.h: updated to latest versions.

2010-07-08 Thore Böckelmann <tboeckel@gmx.de>

  * mccinit.c, Debug.c: updated to latest mccinit.c and added CleanupDebug()
    function needed by mccinit.c.

2010-06-29 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/swedish.ct: added ##codeset line.

2010-06-11 Thore Böckelmann <tboeckel@gmx.de>

  * Install-MCC: extended the final message that a reboot might be necessary to
    be able to use the just installed version.

2010-06-03 Thore Böckelmann <tboeckel@gmx.de>

  * include/SDI_compiler.h: added SIPTR definition.

2010-06-03 Matthias Rustler <mrustler@gmx.de>

  * Fixes for 64-bit AROS. Some ULONG to IPTR changes to get rid of warnings
    about conversion from/to integer to/from pointer with different size.
  * mmakefile.src: Path to header fixed.

2010-05-27 Thore Böckelmann <tboeckel@gmx.de>

  * dist/Install-MCC: the supported languages are now collected dynamically
    instead of being defined statically. Furthermore the .mcc name must be
    specified in the script's icon as application name. This makes it possible
    to use the script for arbitrary classes without modification.
  * dist/icons: set some reasonable default icon positions.

2010-05-26 Thore Böckelmann <tboeckel@gmx.de>

  * dist/Install-MCC: added the first version of a generic MCC Installer script.
    To use this script for other classes only the name and the set of supported
    languages needs to be adapted.

2010-05-25 Matthias Rustler <mrustler@gmx.de>

  * mccinit.c: changes for AROS V1 API
  * mmakefile.scr: icon.c added

2010-05-20 Thore Böckelmann <tboeckel@gmx.de>

  * Makefiles: add varargs stubs only for those systems which really need it.

2010-05-19 Mariusz Danilewicz <mandi@interia.pl>

  * mcp/locale/polish.ct: first version of Polish translation

2010-05-19 Thore Böckelmann <tboeckel@gmx.de>

  * misc: moved the public include files to the include/mui directory.
  * added stuff for automated build of release archives.
  * mcp/locale: slight correction for the polish catalog to generate a proper
    AUTH chunk and set some properties. Also added new polish translation to the
    catalog generation.

#### v11.18 RELEASE ###########################################################

2010-05-01 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.18 release preparations

2010-04-30 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/library.c: added version check for NBitmap.mcc. Only version V15.8+ can
    handle raw image data.

2010-04-27 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/library.c: all systems now try to create a truecolor prefs image using
    Rawimage.mcc first before falling back to the old 8bit images.

2010-04-26 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/misc: merged all converted image data into one file, moved the image
    files to a separate subdirectory.
  * mcp/library.c: combined then prefs icon generation for all platform into one
    function.

2010-04-24 Thore Böckelmann <tboeckel@gmx.de>

  * include/mccinit.c: replaced some #ifdef's by macros.

2010-04-23 Ilkka Lehtoranta <ilkleht@yahoo.com>

  * mcp/misc: use bzip2 compressed 32bit prefs image on MorphOS 2.

2010-04-23 Pavel Fedin <pavel_fedin@mail.ru>

  * include/mccinit.c: use NewStackSwap() under AROS, do not crash any more
  * mcp/library.c: Fixed building on systems without PNG support in Bodychunk.mui
  * mcp/locale/french.ct: Updated french translation (from AROS developers)

2010-04-12 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/misc: added 32bit truecolor prefs image done by Martin 'Mason' Merz.
    This requires at least MUI3.9 and AmigaOS 4.1.

2010-02-10 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/AllocBitMap.c: the CyberGraphics semaphore check was done without the
    necessary Forbid()/Permit() pair. Although it is absolutely unlikely that
    the semaphore will be removed it is better to follow the rules. This fixes
    bug #2948533 of TextEditor.mcc.

2009-11-28 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/ClipboardServer.c: decreased the stack size from 16K to 8K as the server
    process doesn't really need much stack.

#### v11.17 RELEASE ###########################################################

2009-10-24 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.17 release preparations

2009-09-24 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/misc: renamed all pool function to "*Shared*" as this describes what
    they really do.

2009-09-19 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/HandleInput.c, mcc/ClipboardServer.c: the clipboard server process
    now also makes use of the global memory pool.
  * misc: replaced the per-instance memory pool by a global and semaphore
    protected one. There is absolutely no benefit in having a separate pool
    for every instance with only just one allocation within this pool.
  * misc: added a name to all memory pools for OS4.

2009-09-17 Thore Böckelmann <tboeckel@gmx.de>

  * mcp/Makefile: fixed Makefile to be able generate the catalogs.
  * mcp/locale/german.ct: added a missing colon in the german translation.

2009-09-14 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/ClipboardServer.c: added NP_CodeType=CODETYPE_PPC for the MOS build.
  * mcc/BetterString-Test.c: added forced select on activate object.
  * mcc/ClipboardServer.c: fixed wrong server process function prototype for all
    non-OS4 builds.
  * mcc/Debug.c, mcc/Debug.h: added DBF_CLIPBOARD debug flag.
  * mcc/HandleInput.c, mcc/ClipboardServer.c: moved UTF8 conversion function to
    where it belongs.
  * mcc/GetSetAttrs.c: fixed signedness warning for OS4.
  * mcc/ClipboardServer.c, vastubs.c: fixed OS3 build.

2009-09-09 Thore Böckelmann <tboeckel@gmx.de>

  * ClipboardServer.c, HandleInput.c: loaded all clipboard access stuff off to
    a separate process. Accessing the clipboard via iffparse.library requires
    2 user signals for each instance and thus an application would run out of
    free signals sooner or later. Especially YAM suffered from this with more
    than one write window open.

2009-08-14 Thore Böckelmann <tboeckel@gmx.de>

  * Makefiles: added "-g" to the debug flags. It seems the OS3 GCC 2.95.3 cross
    compiler needs this to generate debug infos at all.

2009-06-26 Matthias Rustler <mrustler@gmx.de>

  * mcp/mmakefile.src,
    libraries/mui.h   : backport of some AROS related fixes.

2009-06-24 Thore Böckelmann <tboeckel@gmx.de>

  * Dispatcher.c, HandleInput.c: fixed the SelectOnActive feature in such a way
    that the contents are only selected, if the left mouse button is *not*
    pressed, because MUI issues MUIM_GoActive right after a click on an object.
    Also cleaned up the dispatcher code a bit.
  * PrintString.c: deobfuscated the cursor width calculation.

2009-06-07 Matthias Rustler <mrustler@gmx.de>

  * AROS metamakefiles added.
  * Some 64-bit fixes.
  * BetterString-Test.c: foul language removed.
  * Re-added some fixes from previous AROS port.

2009-06-03 Jens Langner <Jens.Langner@light-speed.de>

  * misc: added dependeny files to our build system and fixed another bunch of
    AROS related compiler warnings/issues.

2009-06-02 Jens Langner <Jens.Langner@light-speed.de>

  * misc: fixed several compiler warning when compiling for AROS and updated
    the SDI headers accordingly.

2009-05-04 Thore Böckelmann <tboeckel@gmx.de>

  * include/SDI_lib.h: updated to the latest version.

2009-05-02 Ilkka Lehtoranta <ilkleht@isoveli.org>

  * include/mccinit.c: RTF_EXTENDED was not set for the MorphOS build making
    revision number ineffective.

2009-04-30 Thore Böckelmann <tboeckel@gmx.de>

  * include/SDI_lib.h: updated to the latest version.

2009-04-20 Pär Boberg <pbobbenb@spray.se>

  * mcp/locale/swedish.ct: updated according to changes.

2009-04-17 Jens Langner <Jens.Langner@light-speed.de>

  * defines/mccclass.h: updated AROS defines header after regeneration with
    sfdc 1.4.

2009-04-01 Thore Böckelmann <tboeckel@gmx.de>

  * mccinit.c: fixed broken stackswap_call() prototype for the assembler
    version.

2009-03-29 Jens Langner <Jens.Langner@light-speed.de>

  * version.h: renamed the rev.h file to version.h in each subdirectory and
    updated it with a more flexible version, system and cpu identification
    model.

2009-03-27 Jens Langner <Jens.Langner@light-speed.de>

  * misc: fixed the linker options to have everything properly linkable with
    the latest AROS SDK.
  * misc: first preparation for a direct AROS cross-compiler compilation.

2009-03-27 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/FileNameCompl.c: changed to unsafe BSTR conversion to something more
    bullet proof. A BSTR is not guaranteed to be NUL-terminated, which the
    former implementation falsely assumed.

2009-02-01 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c, mcc/HandleInput.c: if the SelectOnActive feature was
    active and the object was activated either by the programmers request (i.e.
    by setting MUIA_Window_ActiveObject) the object will now correctly select
    the complete string, instead of doing this right after the first keypress.
    This should fix bug #2504286.

#### v11.16 RELEASE ###########################################################

2009-01-11 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.16 release preparations
  * mcc/HandleInput.c, mcc/Disptacher.c: fixed the newly introduced SelectOnActive
    functionality by selecting all text only if the object has been gone
    active freshly and the user released the mouse button without any text
    manually selected. This should make the behaviour of a BetterString object
    more consistent to what a string object is supposed to do with the
    SelectOnActive feature enabled.

2008-12-31 Ilkka Lehtoranta <ilkleht@isoveli.org>

  * mcc/HandleInput: when pasting text clear only the tail of the buffer.
  * mcc/AllocBitMap.c: Also MorphOS build is now using AllocBitMap()/FreeBitMap()
    only. For maximum performance VMEM bitmap is used. WaitBlit() is now called
    only for OS3 (CGX and P96 synchronise blitters automatically).

2008-12-22 Thore Böckelmann <tboeckel@gmx.de>

  * vastubs.c: added missing stub function for the OS3 build.

2008-12-21 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/AllocBitMap.c: replaced the OS3 specific part (and the deprecated
    AllocMem and AllocVec calls) by simplified code.

2008-12-20 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/Pointer.c: added support for displaying a selection pointer similar to
    what TextEditor.mcc or NList.mcc displays to a user in case the mouse is
    over a BetterString object. Per default the selection pointer is turned on
    but can be globally disabled via a new user definable setting in the mcp.
    There might be still some glitches. So before we can release a new version
    we ought to run some details tests with the selection pointer enabled and
    disabled.
  * mcc,mcp: added a new preference setting to allow a betterstring object to
    automatically select all text in case it will get the active object of a
    window either via a TAB cycle or via mouse activation. In addition, a new
    MUIA_BetterString_SelectOnActive attribute has been added to allow a
    developer to override the user settings for specific cases. However, this
    new functionality is turned off per default as a string gadget in AmigaOS
    usually does not show this behaviour.

2008-12-17 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Dispatcher.c: replaced the deprecated pool function calls by new ones
    for the the OS4 build.

2008-11-04  Ilkka Lehtoranta <ilkleht@isoveli.org>

  * mcc/HandleInput.c: paste from clipboard now also reads CSET chunk and
    converts UTF-8 text to a local 8bit charset. Charset conversion is
    supported in MorphOS 2 only but could be made available to other platforms
    by using codesets.library respectively.

2008-09-22 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/HandleInput.c: replaced the strcpy() call by a memcpy() call, because
    the former appended a NUL character and hence caused the contents to be
    "visibly" overwritten by a pasted string. This fixes bug #2121909.

#### v11.15 RELEASE ###########################################################

2008-06-19 Jens Langner <Jens.Langner@light-speed.de>

  * misc: final 11.15 release preparations

2008-06-15 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: slightly improved the ReadChunkBytes() handling with
    iffparse library. Now the return value is checked correctly and the buffer
    is cleared before placing the bytes from clipboard there. In addition, the
    LF and CR stripping is removed again as this was not the root of bug #1992568
    and LF and CR should be able to be placed in the string object as well.
  * mcc/HandleInput.c: fixed a bug where the keyboard shortcuts didn't work for
    a normal object due to a wrong flag check.
  * locale/italian.ct: updated italian catalog

2008-06-14  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/HandleInput.c, mcc/library.c: replaced the handcrafted clipboard access
    by usage of iffparse.library. Before only the first FTXT chunk was examined,
    which resulted in partial pastes from TextEditor.mcc only in case there were
    multiple lines in the clipboards. LF's and CR's will be replaced by spaces
    and hence multiple lines will be concatenated to one single line. Hopefully
    this fixes bug #1992568.

2008-03-19  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: made MUIA_String_AdvanceOnCR OM_GET'able.

2008-03-17  Thore Böckelmann <tboeckel@gmx.de>

  * #?/vastubs.c, #?/Makefile: added vararg stubs for OS3 to be able to link
    against clib2 which misses these stubs.

2008-03-04  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/Makefile: removed accidently included extrasrc.o dependency.
  * #?/Makefile: removed -lm from the linker libs as nothing needs floating
    point math. Also added dump as target.

2008-02-25  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: minor optimizations
  * mcc/HandleInput.c: fixed a bug introduced by the recent flag checks by
    macros which caused the text to be immediately marked as block.

2008-02-19  Thore Böckelmann <tboeckel@gmx.de>

  * Debug.h: replaced all abort() usages in our ASSERT() macros with the
    respective calls to assert(). This should prevent the MorphOS compile
    from not linking and be a bit more intuitiv.

2008-02-17  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/GetSetAttrs.c: if an empty or NULL string is set as new content the
    selection start index will now be adapted to prevent false markings.

2008-02-07  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/hotkeystring/HandleInput.c: fixed a signedness warning.
  * #?.c: replaced all "value & flag" style bit checks and manipulations by
    isFlagSet() and setFlag() style macros. This should make the source a lot
    more readable and less error prone to wrong checks.

2008-02-02 Jens Langner <Jens.Langner@light-speed.de>

  * mccinit.c: updated to latest version available which fixes some
    MorphOS specific compiler warnings.

2008-01-24  Thore Böckelmann <tboeckel@gmx.de>

   * mcc/FileNameCompl.c, mcc/HandleInput.c, mcc/PrintString.c,
     mcc/Dispatcher.c: added some STYLEGUIDE stuff.

2008-01-04 Vit Sindlar <sindlarv at centrum dot cz>

   * mcp/locale/czech.ct: updated Czech catalog translation

2008-01-03  Thore Böckelmann <tboeckel@gmx.de>

   * mcp/locale/#?.ct: changed all .ct file names to english names instead of
     translated ones.

2007-12-19  Thore Böckelmann <tboeckel@gmx.de>

   * mcc/FileNameCompl.c: ParsePatternNoCase() was called with a too small buffer
     which could have caused trashed memory. This most probably fixes bug
     #1824388.

#### v11.14 RELEASE ###########################################################

2007-12-18 Jens Langner <Jens.Langner@light-speed.de>

   * mcp/mcc: a few v11.14 release preparations.

2007-12-13  Thore Böckelmann <tboeckel@gmx.de>

   * mcp/misc: replaced the old BitmapObject by a BodyChunkObject and added a
     IFF-ILBM image with proper transparent color. This should fix the broken
     display on the prefs image on some old machines.

2007-12-03 Vit Sindlar <sindlarv at centrum dot cz>

   * mcp/locale/czech.ct: added Czech catalog translation

2007-11-05 Jens Langner <Jens.Langner@light-speed.de>

   * mcp/Dispatcher.c, mcc/InitConfig.c: changed the default inactive text color
     to use the shadow pen instead of the text pen. This should a default inactive
     betterstring object a slightly better look.

2007-11-05  Thore Böckelmann <tboeckel@gmx.de>

   * mcc/private.h, mcc/hotkeystring/private.h: added missing rawkey definitions
     for OS3.
   * misc: changed all TABs back to two spaces.

2007-11-03 Jens Langner <Jens.Langner@light-speed.de>

   * mcp/CreatePrefsGroup.c: added a copyright crawling object to the bottom
     of the mcp to match the Look&Feel to our other classes.

2007-11-02 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: the HOME and END key on PC keyboards will now be
    processed and move the cursor to the start/end of the string. This should
    fulfill feature request #1822105.
  * mcp/CreatePrefsGroup.c: the Crawling object will now always carry a grey
    background which should not interfere with any scrolling operation
    anymore.

#### v11.13 RELEASE ###########################################################

2007-09-28 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: introduced new MUIV_BetterString_DoAction_Delete action
    and changed the ClearSelected method to use that new action instead of
    calling DeleteBlock() itself. This in fact should also fix issues where upon
    a ClearSelected call the display of the gadget wasn't properly refreshed.

2007-09-01  Pär Boberg <pbobbenb@spray.se>

  * mcp/locale/svenska.ct: updated according to changes.

2007-08-31 Jens Langner <Jens.Langner@light-speed.de>

  * mcp/locale/italian.ct: updated italian translation kindly provided by
    Samir Hawamdeh.

2007-08-30 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: fixed bug where upon some copy&paste operations via
    DoAction, an eventually marked block in the string wasn't properly
    disabled with the action.

2007-08-29  Thore Böckelmann <tboeckel@gmx.de>

  * mcp/locale/deutsch.ct: updated german translations according to the lastest
    changes.
  * mcp/CreatePrefsGroup.c, mcp/locale/BetterString_mcp.cd: all the help strings
    are now translatable.

#### v11.12 RELEASE ###########################################################

2007-08-26 Jens Langner <Jens.Langner@light-speed.de>

  * mcc/hotkeystring: adapted documentation and minor tweaks to the sources of
    HotkeyString.mcc.
  * mcc/BetterString_mcc.h: converted all MUIV_BetterString_DoAction_#? values
    to a named enum rather than simple defines.

2007-08-18 Jens Langner <Jens.Langner@light-speed.de>

  * mcc: added new MUIM_BetterString_DoAction method which allows to manually
    perform certain actions like Copy/Cut/Paste,... which are normally just
    executed with the default shortcuts. This way the gadget can completly
    controlled remotely.
  * mcc: added new MUIA_BetterString_NoShortcuts attribute that allows to
    disable the default shortcuts like Amiga+C, Amiga+V, etc. for applications
    interested in performing those operations manually.
  * include/mccinit.c: updated to latest 1.10 version

#### v11.11 RELEASE ###########################################################

2007-07-25  Thore Böckelmann <tboeckel@gmx.de>

  * #?/library.c: now really uses the 3 parameter version of GETINTERFACE()
    defined in mccinit.c instead of the old obsolete version in mcc_common.h.
    The user definable functions (i.e. ClassInit()) must be declared before
    the inclusion of mccinit.c.
  * include/mccinit.c: updated to latest 1.8 version which really uses the
    GETINTERFACE() macro with 3 parameters.

2007-07-25 Jens Langner <Jens.Langner@light-speed.de>

  * include/mccinit.c: updated to latest 1.7 version

2007-07-24  Thore Böckelmann <tboeckel@gmx.de>

  * include/mccinit.c: updated to latest 1.6 version which fixes an unbalanced
    if statement.

2007-07-23 Jens Langner <Jens.Langner@light-speed.de>

  * include/mccinit.c: updated to latest 1.5 version which should take care
    of stack issues.

2007-07-05 Jens Langner <Jens.Langner@light-speed.de>

  * include/mccinit.c: updated to latest 1.4 version and adapted all our
    library.c files to make use out of the new stack enforcing mechanisms.

2007-06-13  Thore Böckelmann <tboeckel@gmx.de>

  * #?/Debug.c: unified the _DPRINTF() functions for all platforms.

2007-06-10 Jens Langner <Jens.Langner@light-speed.de>

  * #?/Makefile: minor update/optimization on Makefiles.
  * include/mccinit.c: updated to latest 1.1 version which should fix possible
    stack issues during the LibInit() phase. Custom libraries will now be opened
    during the LibOpen() phase instead while maintaining an own mutual exclusive
    locking variable.

2007-06-09 Jens Langner <Jens.Langner@light-speed.de>

  * include/mccinit.c, mcc/library.c, mcp/library.c: replaced the old obsolete
    mccheader.c by the new mccinit.c which should come with a much more clear
    interface and documentation on how to use it for a basis of a MUI custom
    class. This should significantly reduce the possibility of race conditions
    in the mcc/library init code.

2007-05-29  Thore Böckelmann <tboeckel@gmx.de>

  * include/mccheader.c: reworked the LibOpen() and LibClose() functions to
    increment/decrement the lib_Open counter before obtaining the semaphore to
    prevent a possible race condition with LibExpunge().

#### v11.10 RELEASE ###########################################################

2007-05-19  Jens Langner <Jens.Langner@light-speed.de>

  * mcp/locale/italian.ct: added italian catalog translation kindly provided
    by Samir Hawamdeh.

2007-05-18  Thore Böckelmann <tboeckel@gmx.de>

  * mcc/PrintString.c: the inactive text is now displayed with the standard
    shadow color.
  * mcc/misc: added new attribute MUIA_BetterString_InactiveContents. The
    supplied string will be shown if no other text is available and the object
    is inactive.

2007-04-16  Jens Langner <Jens.Langner@light-speed.de>

  * mcp/locale/dansk.ct: added new danish catalog translation kindly
    provided by Niels Bache.

2007-03-23  Thore Böckelmann <tboeckel@gmx.de>

  * #?/Debug.c: fixed wrong final output of debug classes and flags.

2007-03-11 Thore Böckelmann <tboeckel@gmx.de>

  * #?/Debug.c: disabling a debug flag was not possible due to a check for the
    '!' at a wrong index.

2007-03-08  Jens Langner <Jens.Langner@light-speed.de>

  * misc: fixed bug #1676749 where all BetterString classes did check for
    a minimum version of keymap.library of v38 whereas the OS 3.0 version
    is normally v37.2. This prevented the use of BetterString on OS 3.0
    machines.

2007-03-07  Jens Langner <Jens.Langner@light-speed.de>

  * mcp/locale/russian.ct: added russian catalog translation kindly provided
    by Vlad Vinogradov.

#### v11.9 RELEASE ############################################################

2007-03-06  Jens Langner <Jens.Langner@light-speed.de>

  * misc: fixed several compiler warnings
  * misc: replaced all single-target makefiles with general "Makefile"
    that automatically identifies the build target via uname.

2007-03-04 Thore Böckelmann <tboeckel@gmx.de>

  * all makefiles: all makefiles were still accessing the no longer existing
    directory "includes" instead of "include".

2007-01-02  Jens Langner <Jens.Langner@light-speed.de>

  * misc: updated all copyright notices to 2007.
  * mcp/locale/french.ct: added french catalog translation kindly provided
    by Philippe Bovier.

2006-11-28  Jens Langner <Jens.Langner@light-speed.de>

  * mcp/locale/svenska.ct: added swedish catalog translation kindly provided
    by Pär Boberg.

2006-10-06  Jens Langner <Jens.Langner@light-speed.de>

  * includes/SDI_#?, misc: updated to latest versions and updated our sources
    accordingly.

2006-09-30 Thore Böckelmann <tboeckel@gmx.de>

  * mcc/hotkeystring/HandleInput.c: fixed bug #1568031 where a wrong index
    calculation which shifted all F-keys and cursor keys by one, making all
    inputs wrong.
  * mcc/Debug.c, mcp/Debug.c, mcc/hotkeystring/Debug.c: corrected several
    wrong class names in the debug output.

#### v11.8 RELEASE ############################################################

2006-08-20  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: fixed bug #1218170 where on "MUIA_String_Secret"
    enabled objects the doubleclicking marking of text should not select
    single words.
  * mcc/HandleInput.c: on double-clicked into a betterstring gadget, text
    passages will only be marked if the user really always clicked on the
    very same position in the string. Otherwise marking will be removed.
  * mcc/InitConfig.c: fixed a bug in the font name parsing/loading routines
    which didn't work as expected and could crash a machine under certain
    situations.
  * misc: replaced all bufferoverflow prone functions like sprintf() against
    safe functions.
  * mcc/Dispatcher.c: if a BetterString gadget moves into 'Inactive' state,
    eventually selected content will be automatically unselected as it is done
    with the default MUI string class.
  * misc: switched all OS4 builds to compile against newlib.library.
  * misc: updated 'mccheader.c' include file from latest TextEditor.mcc
    sources and also applied the new Debug.c,h interface to all our subprojects.
  * mcc/hotkeystring/HandleInput.c: fixed the OS4 build to use the new media
    key definitions instead.

2005-07-30  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/hotkeystring/HandleInput.c: changed the rawkey based wheelmouse name to
    carry a "nm_" prefix so that it refers to newmouse based wheelmouse events
    and doesn't conflict with the new wheelmouse events in AmigaOS4.

#### v11.7 RELEASE ############################################################

2005-07-07  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/library.c: added missing USEDCLASSESP define so that MUI knowns
    which mcp class belongs to the mcc.

2005-07-07  Ilkka Lehtoranta <ilkleht@isoveli.org>

  * mcc/hotkeystring/HandleInput.c: changed CONST CONST_STRPTR back to
    const char *, as requested.

2005-07-04  Ilkka Lehtoranta <ilkleht@isoveli.org>

  * mcc/hotkeystring/HandleInput.c: made small changes only to create
    (possibly) smaller code.

2005-07-03  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/GetSetAttrs.c: fixed a minor bug in the MUIA_String_Integer set
    method which prevented it from correctly converting the supplied
    integer into a string and therefore left the method defective.

2005-07-02  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/hotkeystring/HandleInput.c: added missing <proto/intuition.h>
    include statements which prevent compilation with OS4 SDK (missing
    SetAttrs)

2005-06-30  Gunther Nikl <gni@gecko.de>

  * mcc/HandleInput.c (ConvertKey): fix signedness bug.
  * mcc/hotkeystring/HandleInput.c (ConvertKey): Likewise.

2005-06-24  Gunther Nikl <gni@gecko.de>

  * mcc/AllocBitMap.c: Free allocated bitmap on failure in non-V39 case.
    Move version check into USE_OS3 #define.
    (MUIG_AllocBitMap): Improved friend handling.
  * mcc/AllocFunctions.c: Minor changes.

2005-06-16  Gunther Nikl <gni@gecko.de>

  * mcc/HandleInput.c: Fix OS3 MySPrintf for GCC 3.4.x or newer (has to
    use stdarg.h macros!). Small cleanup (eg. STRPTR -> char*).

2005-06-15  Gunther Nikl <gni@gecko.de>

  * mcc/hotkeystring/Makefile.os3: Added $(CPU) to $LDFLAGS. Added INCDIR=
    setting and used it where appropriate.
  * mcc/hotkeystring/HotkeyString-Test.c Added libraries/iffparse.h for
    MAKE_ID define. Includes cleanup.
  * mcc/hotkeystring/private.h: Replaced proto/mui.h with libraries/mui.h.
  * mcc/hotkeystring/HandleInput.c: Replaced STRPTR and friends with char*
    (thats what standard functions use!). Include and code cleanup.

2005-06-14  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/hotkeystring: replaced the fixed values for the special OS4/MOS keys
    by a more general set of RAWKEY_ defines already common on both platforms
  * mcc/hotkeystring: fixed a whole bunch of compiler warnings
  * mcc: fixed a bunch of compiler warnings

2005-06-13  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/TextFunctions.c: replace our own MyTextLength/MyTextFit with the
    standard OS TextLength/TextFit functions as they work exactly the same
    and are hopefully less buggy.

2005-05-25  Jens Langner <Jens.Langner@light-speed.de>

  * library.c: added missing USE_UTILITYBASE define which may have caused
    problems on OS3 machines.

2005-05-19  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/TextFunctions.c: adapted sources to the already fixed function
    equivalents used in TextEditor.mcc.

2005-05-03  Ilkka Lehtoranta <ilkleht@isoveli.org>

  * mcc/hotkeystring/HandleInput.c: Added missing key codes for MorphOS
    and AmigaOS4 (may contain wrong codes).
  * mcc/hotkeystring/HandleInput.c: Added media keys.
  * mcc/hotkeystring/Dispatcher.c (OM_SET):
    Added MUIA_HotkeyString_IX tag. Takes struct InputXpression as data
    and sets a gadget contents accordingly.
  * misc: Restored spaces to ChangeLog.

2005-05-03  Jens Langner <Jens.Langner@light-speed.de>

  * mcc/HandleInput.c: fixed an uninitialized variable by integrating
    the proposed patch of bug 1193352 from Georg Steger.
  * misc: integrated minor patches kindly provided by Gunther Nikl
    and modified sources to properly compile with gcc versions < 3.

2005-04-21  Jens Langner <Jens.Langner@light-speed.de>

  * initial LGPL release published at sf.net
